## boost-ext-ut 2.3.1

=== CMakeLists.txt ===
#
# Copyright (c) 2019-2020 Kris Jusiak (kris at jusiak dot net)
#
# Distributed under the Boost Software License, Version 1.0.
# (See accompanying file LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt)
#
option(BOOST_UT_DISABLE_MODULE "Disable ut module" ON)

if(NOT BOOST_UT_DISABLE_MODULE)
cmake_minimum_required(VERSION 4.0.0)
set(CMAKE_CXX_STANDARD 23)
set(CMAKE_EXPERIMENTAL_CXX_IMPORT_STD "a9e1cf81-9932-4810-974b-6eccaf14e457")
set(CMAKE_CXX_MODULE_STD 1)
else()
cmake_minimum_required(VERSION 3.21...3.25)
endif()
project(
  ut
  VERSION 2.3.1
  LANGUAGES CXX
)

if(NOT DEFINED CMAKE_CXX_STANDARD)
  set(CMAKE_CXX_STANDARD
      20
      CACHE STRING "Default value for CXX_STANDARD property of targets."
  )
  option(CMAKE_CXX_STANDARD_REQUIRED "Default value for CXX_STANDARD_REQUIRED property of targets." YES)
  option(CMAKE_CXX_EXTENSIONS "Default value for CXX_EXTENSIONS property of targets." NO)
endif()

option(BOOST_UT_ENABLE_MEMCHECK "Run the unit tests and examples under valgrind if it is found" OFF)
option(BOOST_UT_ENABLE_COVERAGE "Run coverage" OFF)
option(BOOST_UT_ENABLE_SANITIZERS "Build with sanitizers" OFF)
option(BOOST_UT_BUILD_BENCHMARKS "Build the benchmarks" OFF)
option(BOOST_UT_BUILD_EXAMPLES "Build the examples" ${PROJECT_IS_TOP_LEVEL})
option(BOOST_UT_BUILD_TESTS "Build the tests" ${PROJECT_IS_TOP_LEVEL})
option(BOOST_UT_ENABLE_INSTALL "Enable install targets" ${PROJECT_IS_TOP_LEVEL})
option(BOOST_UT_USE_WARNINGS_AS_ERORS "Build the tests" ${PROJECT_IS_TOP_LEVEL})

add_library(ut INTERFACE)
if(NOT BOOST_UT_DISABLE_MODULE)
add_library(ut_module)
endif()
target_include_directories(ut INTERFACE $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>)
target_compile_features(ut INTERFACE cxx_std_20)
if(NOT BOOST_UT_DISABLE_MODULE)
target_compile_features(ut_module INTERFACE cxx_std_23)
endif()

if(BOOST_UT_USE_WARNINGS_AS_ERORS)
  include(cmake/WarningsAsErrors.cmake)
endif()

add_custom_target(style COMMENT "Running clang-format")
add_custom_command(
  TARGET style
  POST_BUILD
  COMMAND find ${CMAKE_CURRENT_LIST_DIR}/benchmark ${CMAKE_CURRENT_LIST_DIR}/example ${CMAKE_CURRENT_LIST_DIR}/include
          ${CMAKE_CURRENT_LIST_DIR}/test -iname "*.hpp" -or -iname "*.cpp" | xargs clang-format -i
  COMMENT "Running clang-format"
)

if(BOOST_UT_ENABLE_COVERAGE)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} --coverage")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -ggdb3 -O0")
endif()

if(BOOST_UT_ENABLE_SANITIZERS)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -O0 -g -fno-omit-frame-pointer
  -fsanitize=address,leak,undefined"
  )
endif()

if(BOOST_UT_DISABLE_MODULE)
  target_compile_definitions(ut INTERFACE BOOST_UT_DISABLE_MODULE)
endif()

if(NOT BOOST_UT_DISABLE_MODULE)
target_sources(ut_module PUBLIC FILE_SET CXX_MODULES FILES include/boost/ut.cppm)
endif()

if(NOT TARGET Boost::ut)
  add_library(Boost::ut ALIAS ut)
endif()

if(NOT BOOST_UT_DISABLE_MODULE)
add_library(Boost::ut_module ALIAS ut_module)
endif()

include(GNUInstallDirs)
include(CMakePackageConfigHelpers)

install(
  FILES include/boost/ut.hpp include/boost/ut.cppm
  DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/boost
)

install(
  TARGETS ut
  EXPORT ut_Targets
  INCLUDES DESTINATION include
)
install(
  EXPORT ut_Targets
  FILE utConfig.cmake
  NAMESPACE Boost::
  DESTINATION lib/cmake/ut
)

write_basic_package_version_file(
  "utConfigVersion.cmake"
  VERSION ${PROJECT_VERSION}
  COMPATIBILITY SameMajorVersion
  ARCH_INDEPENDENT
)
install(
  FILES "${PROJECT_BINARY_DIR}/utConfigVersion.cmake"
  DESTINATION lib/cmake/ut
)

if(EMSCRIPTEN)
  set(CMAKE_EXECUTABLE_SUFFIX ".js")
  target_link_options(ut INTERFACE "SHELL:-s ALLOW_MEMORY_GROWTH=1" "SHELL:-s EXIT_RUNTIME=1" -fwasm-exceptions -g)
  target_compile_options(ut INTERFACE -fwasm-exceptions -g)
endif()

# Note: now we can use the target Boost::ut
include(cmake/AddCustomCommandOrTest.cmake)

if(BOOST_UT_BUILD_BENCHMARKS)
  add_subdirectory(benchmark)
endif()
if(BOOST_UT_BUILD_EXAMPLES)
  add_subdirectory(example)
endif()
if(BOOST_UT_BUILD_TESTS)
  enable_testing()

  add_subdirectory(test)
endif()

=== benchmark/CMakeLists.txt ===
#
# Copyright (c) 2019-2020 Kris Jusiak (kris at jusiak dot net)
#
# Distributed under the Boost Software License, Version 1.0.
# (See accompanying file LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt)
#
function(benchmark name file)
  add_executable(b${name} ${file}.cpp)
  target_compile_options(b${name} PRIVATE ${ARGN})
  target_link_libraries(b${name} PRIVATE Boost::ut)
  ut_add_custom_command_or_test(TARGET b${name} COMMAND b${name})
endfunction()

benchmark(expect_udl expect "-DEXPECT_UDL")
benchmark(expect_that expect "-DEXPECT_THAT")
benchmark(expect_eq expect "-DEXPECT_EQ")
benchmark(include include)
benchmark(suite suite)
benchmark(test test)

=== example/CMakeLists.txt ===
#
# Copyright (c) 2019-2020 Kris Jusiak (kris at jusiak dot net)
#
# Distributed under the Boost Software License, Version 1.0.
# (See accompanying file LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt)
#
find_program(BOOST_UT_MEMORYCHECK_COMMAND valgrind)

function(example file target)
  add_executable(boost_ut_${target} ${file}.cpp)
  if(BOOST_UT_ENABLE_MEMCHECK AND BOOST_UT_MEMORYCHECK_COMMAND)
    ut_add_custom_command_or_test(
      TARGET
      boost_ut_${target}
      COMMAND
      ${BOOST_UT_MEMORYCHECK_COMMAND}
      --leak-check=full
      --error-exitcode=1
      ./boost_ut_${target}
      ${ARGN}
    )
  else()
    ut_add_custom_command_or_test(TARGET boost_ut_${target} COMMAND boost_ut_${target} ${ARGN})
  endif()
endfunction()

example(cfg/printer printer)
example(cfg/runner runner)

if(APPLE OR "${CMAKE_CXX_COMPILER_ID}" MATCHES "Clang")
  example(cfg/parallel_runner parallel_runner)
endif()

# if(DEFINED ENV{TBB_ROOT})
#   set(TBB_ROOT $ENV{TBB_ROOT})
#   # FIXME: include could not find load file:
#   include(${TBB_ROOT}/cmake/TBBBuild.cmake)
#   tbb_build(TBB_ROOT ${TBB_ROOT} CONFIG_DIR TBB_DIR MAKE_ARGS stdver="c++17")
#   find_package(TBB)
#   target_link_libraries(boost_ut_parallel_runner ${TBB_IMPORTED_TARGETS})
# endif()

example(cfg/reporter reporter)

if(NOT WIN32)
  example(abort abort)
endif()

example(attr attr)
example(BDD BDD)
example(benchmark benchmark)
example(cli cli_pass "cli.pass")
example(cli cli_pass_no_colors "cli.pass" "0" "1")
example(cli cli_pass_dry_run "cli.pass" "1" "1")
example(cli cli_pass_not_dry_run "cli.pass" "1" "0")
example(cli cli_all_dry_run "\\*" "1" "1")
example(cli cli_fail_dry_run "cli.fail" "1" "1")
example(exception exception)
example(expect expect)
example(fatal fatal)
example(filter filter)

if(NOT WIN32 AND "${CMAKE_CXX_COMPILER_ID}" MATCHES "Clang")
  example(gherkin gherkin)
  example(gherkin gherkin_feature "../../example/gherkin.feature")
endif()

example(hello_world hello_world)
example(log log)
example(macro macro)
example(main main '')
example(minimal minimal)
example(mut mut)
example(matcher matcher)

if(NOT "${CMAKE_CXX_COMPILER_ID}" MATCHES "AppleClang")
  example(parameterized parameterized)
endif()

example(run run)
example(run_report run_report)
example(section section)
example(should should)
example(skip skip)
example(sl sl)
example(spec spec)
example(suite suite)
example(tag tag)
example(terse terse)
example(test _test)
example(tmp tmp)
example(using using)

=== test/CMakeLists.txt ===
#
# Copyright (c) 2019-2020 Kris Jusiak (kris at jusiak dot net)
#
# Distributed under the Boost Software License, Version 1.0.
# (See accompanying file LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt)
#
cmake_minimum_required(VERSION 3.12...3.23)
project(boost.ut.test LANGUAGES CXX)

if(TEST_INSTALLED_VERSION)
  if(NOT DEFINED CMAKE_CXX_STANDARD)
    option(CXX_STANDARD_REQUIRED "Require c++ standard" YES)
    if(NOT DEFINED CMAKE_CXX_STANDARD)
      set(CMAKE_CXX_STANDARD
          20
          CACHE STRING "Default value for CXX_STANDARD property of targets."
      )
      option(CMAKE_CXX_STANDARD_REQUIRED "Default value for CXX_STANDARD_REQUIRED property of targets." YES)
      option(CMAKE_CXX_EXTENSIONS "Default value for CXX_EXTENSIONS property of targets." NO)
    endif()
  endif()

  find_package(ut REQUIRED)
  include(../cmake/AddCustomCommandOrTest.cmake)

  enable_testing()
endif()

add_subdirectory(ut)
add_subdirectory(ft)

=== test/ft/CMakeLists.txt ===
#
# Copyright (c) 2019-2020 Kris Jusiak (kris at jusiak dot net)
#
# Distributed under the Boost Software License, Version 1.0.
# (See accompanying file LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt)
#
include_directories(include)

add_executable(ft main.cpp test_suite_1.cpp test_suite_2.cpp test_suite_3.cpp)
ut_add_custom_command_or_test(TARGET ft COMMAND ft)

add_executable(ft-no-exceptions main.cpp test_suite_1.cpp test_suite_2.cpp test_suite_3.cpp)
ut_add_custom_command_or_test(TARGET ft-no-exceptions COMMAND ft-no-exceptions)

if("${CMAKE_CXX_COMPILER_ID}" MATCHES "Clang")
  if(WIN32)
    set_source_files_properties(test_suite_1.cpp PROPERTIES COMPILE_FLAGS /EHsc)
    set_source_files_properties(test_suite_3.cpp PROPERTIES COMPILE_FLAGS /EHsc)
  else()
    set_source_files_properties(test_suite_1.cpp PROPERTIES COMPILE_FLAGS -fno-exceptions)
    set_source_files_properties(test_suite_3.cpp PROPERTIES COMPILE_FLAGS -fno-exceptions)
  endif()
elseif("${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU")
  set_source_files_properties(test_suite_1.cpp PROPERTIES COMPILE_FLAGS -fno-exceptions)
  set_source_files_properties(test_suite_3.cpp PROPERTIES COMPILE_FLAGS -fno-exceptions)
elseif("${CMAKE_CXX_COMPILER_ID}" STREQUAL "MSVC")
  set_source_files_properties(test_suite_1.cpp PROPERTIES COMPILE_FLAGS /EHsc)
  set_source_files_properties(test_suite_3.cpp PROPERTIES COMPILE_FLAGS /EHsc)
endif()

if(NOT WIN32) # WIN32 includes both MSVC and clang-cl
  add_executable(ft-link main.cpp test_suite_1.cpp test_suite_2.cpp test_suite_3.cpp)
  ut_add_custom_command_or_test(TARGET ft-link COMMAND ft-link)
endif()

=== test/ut/CMakeLists.txt ===
#
# Copyright (c) 2019-2020 Kris Jusiak (kris at jusiak dot net)
#
# Distributed under the Boost Software License, Version 1.0.
# (See accompanying file LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt)
#
find_program(BOOST_UT_MEMORYCHECK_COMMAND valgrind)

if(BOOST_UT_ENABLE_MEMCHECK AND BOOST_UT_MEMORYCHECK_COMMAND)
  function(ut name)
    add_executable(${name}_test ${name}.cpp)
    ut_add_custom_command_or_test(
      TARGET
      ${name}_test
      COMMAND
      ${BOOST_UT_MEMORYCHECK_COMMAND}
      --leak-check=full
      --error-exitcode=1
      ${CMAKE_CROSSCOMPILING_EMULATOR}
      ./${name}_test
    )
  endfunction()
else()
  function(ut name)
    add_executable(${name}_test ${name}.cpp)
    ut_add_custom_command_or_test(TARGET ${name}_test COMMAND ${CMAKE_CROSSCOMPILING_EMULATOR} ${name}_test)
  endfunction()
endif()

ut(ut)
if(WIN32)
  ut(win_compat_test)
endif()

=== debian/changelog ===
boost-ext-ut (2.3.1-2) unstable; urgency=medium

  * Mark as Multi-Arch: foreign.

 -- Raul Tambre <raul@tambre.ee>  Sat, 05 Apr 2025 12:02:39 +0300

boost-ext-ut (2.3.1-1) unstable; urgency=medium

  * Update upstream.
  * Drop debian/patches/arch-indep.patch (merged upstream).
  * Switch debian/watch to Git mode.

 -- Raul Tambre <raul@tambre.ee>  Fri, 04 Apr 2025 14:04:36 +0300

boost-ext-ut (2.3.0-2) unstable; urgency=medium

  * Source-only upload.

 -- Raul Tambre <raul@tambre.ee>  Fri, 04 Apr 2025 10:48:53 +0300

boost-ext-ut (2.3.0-1) unstable; urgency=medium

  * Initial release (Closes: #1092173).

 -- Raul Tambre <raul@tambre.ee>  Fri, 28 Mar 2025 13:32:28 +0200

=== debian/control ===
Source: boost-ext-ut
Section: libdevel
Priority: optional
Maintainer: Raul Tambre <raul@tambre.ee>
Homepage: https://boost-ext.github.io/ut/
Vcs-Browser: https://salsa.debian.org/tambre/boost-ext-ut
Vcs-Git: https://salsa.debian.org/tambre/boost-ext-ut.git
Standards-Version: 4.7.2
Rules-Requires-Root: no
Build-Depends:
 cmake,
 debhelper-compat (= 13),
 dh-sequence-single-binary,
 valgrind-if-available <!nocheck>,

Package: libboost-ext-ut-dev
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: C++ single header/module, macro-free unit testing framework
 Boost μt is an easy-to-integrate single header/module C++20 TDD/BDD unit
 testing framework.

=== debian/rules ===
#!/usr/bin/make -rf

ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
CONFIGURE_FLAGS += \
	-DBOOST_UT_BUILD_EXAMPLES=OFF \
	-DBOOST_UT_BUILD_TESTS=OFF
else
CONFIGURE_FLAGS += \
	-DBOOST_UT_BUILD_BENCHMARKS=ON \
	-DBOOST_UT_ENABLE_MEMCHECK=ON
endif

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- $(CONFIGURE_FLAGS)

=== debian/watch ===
version=4
opts=mode=git https://github.com/boost-ext/ut.git refs/tags/v@ANY_VERSION@
